// -*- C++ -*-
// $Id: ConstMinusParameter.hh,v 1.2 2001/05/16 05:10:29 joeb Exp $
//--------------------------ConstMinusParameter-----------------------------//
//                                                                          //
// ConstMinusParameter, result of subtracting a parameter from a constant.  //
// Joe Boudreau, Petar Maksimovic, November 1999                            //
//                                                                          //
//--------------------------------------------------------------------------//

#ifndef ConstMinusParameter_h
#define ConstMinusParameter_h 1
#include "CLHEP/GenericFunctions/AbsParameter.hh"

HEP_BEGIN_NAMESPACE(Genfun)

  class ConstMinusParameter : public AbsParameter  {

    PARAMETER_OBJECT_DEF(ConstMinusParameter)
  
      public:
  
    // Constructor
    ConstMinusParameter(double, const AbsParameter *);
  
    // Copy constructor
    ConstMinusParameter(const ConstMinusParameter &right);

    // Destructor
    virtual ~ConstMinusParameter();
  
    // Retreive function value
    virtual double getValue() const;

  private:

    // It is illegal to assign a ConstMinusParameter
    const ConstMinusParameter & operator=(const ConstMinusParameter &right);

    double        _constant;
    AbsParameter *_parameter;
  };
HEP_END_NAMESPACE(Genfun)
#endif
