// -*- C++ -*-
// $Id: ConstPlusParameter.hh,v 1.2 2001/05/16 05:10:30 joeb Exp $
//--------------------------ConstPlusParameter------------------------------//
//                                                                          //
// ConstPlusParameter, result of adding a constant to a parameters.         //
// Joe Boudreau, Petar Maksimovic, November 1999                            //
//                                                                          //
//--------------------------------------------------------------------------//

#ifndef ConstPlusParameter_h
#define ConstPlusParameter_h 1
#include "CLHEP/GenericFunctions/AbsParameter.hh"

HEP_BEGIN_NAMESPACE(Genfun)

  class ConstPlusParameter : public AbsParameter  {

    PARAMETER_OBJECT_DEF(ConstPlusParameter)
  
      public:
  
    // Constructor
    ConstPlusParameter(double, const AbsParameter *);
  
    // Copy constructor
    ConstPlusParameter(const ConstPlusParameter &right);

    // Destructor
    virtual ~ConstPlusParameter();
  
    // Retreive function value
    virtual double getValue() const;

  private:

    // It is illegal to assign a ConstPlusParameter
    const ConstPlusParameter & operator=(const ConstPlusParameter &right);

    double        _constant;
    AbsParameter *_parameter;
  };
HEP_END_NAMESPACE(Genfun)
#endif
