// -*- C++ -*-
// $Id: ConstTimesParameter.hh,v 1.2 2001/05/16 05:10:30 joeb Exp $
//--------------------------ConstTimesParameter-----------------------------//
//                                                                          //
// ConstTimesParameter, result of subtracting a parameter from a constant.  //
// Joe Boudreau, Petar Maksimovic, November 1999                            //
//                                                                          //
//--------------------------------------------------------------------------//

#ifndef ConstTimesParameter_h
#define ConstTimesParameter_h 1
#include "CLHEP/GenericFunctions/AbsParameter.hh"

HEP_BEGIN_NAMESPACE(Genfun)

  class ConstTimesParameter : public AbsParameter  {

    PARAMETER_OBJECT_DEF(ConstTimesParameter)
  
      public:
  
    // Constructor
    ConstTimesParameter(double, const AbsParameter *);
  
    // Copy constructor
    ConstTimesParameter(const ConstTimesParameter &right);

    // Destructor
    virtual ~ConstTimesParameter();
  
    // Retreive function value
    virtual double getValue() const;

  private:

    // It is illegal to assign a ConstTimesParameter
    const ConstTimesParameter & operator=(const ConstTimesParameter &right);

    double        _constant;
    AbsParameter *_parameter;
  };
HEP_END_NAMESPACE(Genfun)
#endif
