// -*- C++ -*-
// $Id: Exp.hh,v 1.1 2001/05/16 05:10:31 joeb Exp $
//---------------------Exp--------------------------------------------------//
//                                                                          //
// Class Exp                                                                //
// Joe Boudreau, Petar Maksimovic, November 1999                            //
//                                                                          //
//--------------------------------------------------------------------------//
#ifndef Exp_h
#define Exp_h 1
#include "CLHEP/GenericFunctions/AbsFunction.hh"
#include "CLHEP/GenericFunctions/Parameter.hh"

HEP_BEGIN_NAMESPACE(Genfun)

  class Exp : public AbsFunction  {

    FUNCTION_OBJECT_DEF(Exp)

      public:

    // Constructor
    Exp();

    // Copy constructor
    Exp(const Exp &right);
  
    // Destructor
    virtual ~Exp();
  
    // Retreive function value
    virtual double operator ()(double argument) const;
    virtual double operator ()(const Argument & a) const {return operator() (a[0]);}
  
    // Derivative.  
    Derivative partial (unsigned int) const;

    // Does this function have an analytic derivative?
    virtual bool hasAnalyticDerivative() const {return true;}

  private:

    // It is illegal to assign an adjustable constant
    const Exp & operator=(const Exp &right);

  };
HEP_END_NAMESPACE(Genfun)
#endif
