// -*- C++ -*-
// $Id: ParameterProduct.hh,v 1.2 2001/05/16 05:10:35 joeb Exp $
//--------------------------ParameterProduct--------------------------------//
//                                                                          //
// ParameterProduct, result of multiplication of two parameters.            //
// Joe Boudreau, Petar Maksimovic, November 1999                            //
//                                                                          //
//--------------------------------------------------------------------------//

#ifndef ParameterProduct_h
#define ParameterProduct_h 1
#include "CLHEP/GenericFunctions/AbsParameter.hh"

HEP_BEGIN_NAMESPACE(Genfun)

  class ParameterProduct : public AbsParameter  {
  
    PARAMETER_OBJECT_DEF(ParameterProduct)

      public:
  
    // Constructor
    ParameterProduct(const AbsParameter *arg1, const AbsParameter *arg2);
  
    // Copy constructor
    ParameterProduct(const ParameterProduct &right);

    // Destructor
    virtual ~ParameterProduct();
  
    // Retreive function value
    virtual double getValue() const;

  private:

    // It is illegal to assign a ParameterProduct
    const ParameterProduct & operator=(const ParameterProduct &right);

    AbsParameter *_arg1;
    AbsParameter *_arg2;
  };
HEP_END_NAMESPACE(Genfun)
#endif
