// -*- C++ -*-
// $Id: ParameterQuotient.hh,v 1.2 2001/05/16 05:10:36 joeb Exp $
//--------------------------ParameterQuotient-------------------------------//
//                                                                          //
// ParameterQuotient, result of division of two parameters.                 //
// Joe Boudreau, Petar Maksimovic, November 1999                            //
//                                                                          //
//--------------------------------------------------------------------------//

#ifndef ParameterQuotient_h
#define ParameterQuotient_h 1
#include "CLHEP/GenericFunctions/AbsParameter.hh"
HEP_BEGIN_NAMESPACE(Genfun)
  class ParameterQuotient : public AbsParameter  {

    PARAMETER_OBJECT_DEF(ParameterQuotient)
  
      public:
  
    // Constructor
    ParameterQuotient(const AbsParameter *arg1, const AbsParameter *arg2);
  
    // Copy constructor
    ParameterQuotient(const ParameterQuotient &right);

    // Destructor
    virtual ~ParameterQuotient();
  
    // Retreive function value
    virtual double getValue() const;

  private:

    // It is illegal to assign a ParameterQuotient
    const ParameterQuotient & operator=(const ParameterQuotient &right);

    AbsParameter *_arg1;
    AbsParameter *_arg2;
  };
HEP_END_NAMESPACE(Genfun)
#endif
