// -*- C++ -*-
// $Id: ParameterSum.hh,v 1.2 2001/05/16 05:10:36 joeb Exp $
//--------------------------ParameterSum------------------------------------//
//                                                                          //
// ParameterSum, result of addition of two parameters.                      //
// Joe Boudreau, Petar Maksimovic, November 1999                            //
//                                                                          //
//--------------------------------------------------------------------------//

#ifndef ParameterSum_h
#define ParameterSum_h 1
#include "CLHEP/GenericFunctions/AbsParameter.hh"

HEP_BEGIN_NAMESPACE(Genfun)

  class ParameterSum : public AbsParameter  {

    PARAMETER_OBJECT_DEF(ParameterSum)
  
      public:
  
    // Constructor
    ParameterSum(const AbsParameter *arg1, const AbsParameter *arg2);
  
    // Copy constructor
    ParameterSum(const ParameterSum &right);

    // Destructor
    virtual ~ParameterSum();
  
    // Retreive function value
    virtual double getValue() const;

  private:

    // It is illegal to assign a ParameterSum
    const ParameterSum & operator=(const ParameterSum &right);

    AbsParameter *_arg1;
    AbsParameter *_arg2;
  };
HEP_END_NAMESPACE(Genfun)
#endif
